SystemOrganization addCategory: #'PLP-TP3-Pokemon'!

Object subclass: #Pokemon
	instanceVariableNames: 'nombre nivel energia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3-Pokemon'!

!Pokemon class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:27'!
ataqueBase
	self subclassResponsibility.! !

!Pokemon class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:27'!
defensaBase
	self subclassResponsibility.! !

!Pokemon class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:27'!
energiaBase
	self subclassResponsibility.! !

!Pokemon class methodsFor: 'as yet unclassified' stamp: 'NicolasRavasi 6/16/2012 02:27'!
nuevaEspecie: nombreEspecie conTipo: nombreTipo energiaBase: eb ataqueBase: ab defensaBase: db
	| newSpecies |
	newSpecies := Pokemon subclass: nombreEspecie asSymbol.
	newSpecies class compile: 'ataqueBase ^' , ab name asString.
	newSpecies class compile: 'defensaBase ^' , db name asString.
	newSpecies class compile: 'energiaBase ^' , eb name asString.
	newSpecies class compile: 'tipo ^Tipo new: ' , nombreTipo name asString.
	newSpecies class compile: 'new: nombrePokemon ^self new initialize: nombrePokemon '.
	^ newSpecies! !

!Pokemon class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:27'!
tipo
	self subclassResponsibility.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:31'!
ataque
	^ (self class ataqueBase * 2 + 94) * (nivel / 100) + 5! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:35'!
curar: valor
	energia := energia + valor < self energiaTotal
		ifTrue: [ energia + valor ]
		ifFalse: self energiaTotal! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:31'!
defensa
	^ (self class defensaBase * 2 + 94) * (nivel / 100) + 5! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:29'!
energia
	^ energia! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:30'!
energiaTotal
	^(self class energiaBase * 2 + 94) * (nivel / 100) + 10 + nivel! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:34'!
herir: valor
	energia := energia > valor
		ifTrue: [ energia - valor ]
		ifFalse: 0! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/15/2012 00:29'!
initialize: nombrePokemon
	nombre := nombrePokemon.
	nivel := 1.
	energia := self energiaTotal! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:28'!
nivel
	^nivel! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:28'!
nombre
	^nombre! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:28'!
tipo
	^self class tipo! !

Object subclass: #Tipo
	instanceVariableNames: 'nombre efectividades'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3-Pokemon'!

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:49'!
cargarTiposIniciales
	| fuego agua normal planta fantasma |
	fuego := Tipo getInstance: 'fuego'.
	agua := Tipo getInstance: 'agua'.
	normal := Tipo getInstance: 'normal'.
	planta := Tipo getInstance: 'planta'.
	fantasma := Tipo getInstance: 'fantasma'.
	fuego efectividad: 1 / 2 contra: 'fuego'.
	fuego efectividad: 1 / 2 contra: 'agua'.
	fuego efectividad: 2 contra: 'planta'.
	agua efectividad: 2 contra: 'fuego'.
	agua efectividad: 1 / 2 contra: 'agua'.
	agua efectividad: 1 / 2 contra: 'planta'.
	normal efectividad: 0 contra: 'fantasma'.
	planta efectividad: 1 / 2 contra: 'fuego'.
	planta efectividad: 2 contra: 'agua'.
	planta efectividad: 1 / 2 contra: 'planta'.
	fantasma efectividad: 0 contra: 'normal'.
	fantasma efectividad: 2 contra: 'fantasma'! !

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:05'!
existeTipo: nombreTipo 
	Tipo
		iterateInstancesSearchFor: nombreTipo
		andDo: [:v | ^ true ]
		ifAbsent: [:v | ^ false ]! !

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:04'!
getInstance: nombreTipo
	Tipo
		iterateInstancesSearchFor: nombreTipo
		andDo: [ :val | ^ val ]
		ifAbsent: [ :nombre | ^ Tipo new initializeOnNombre: nombre ]! !

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:05'!
iterateInstancesSearchFor: nombreTipo andDo: aBlock ifAbsent: anotherBlock
	Tipo
		allInstancesDo: [ :each | 
			each nombre = nombreTipo
				ifTrue: [ ^ aBlock value: each ] ].
	^ anotherBlock value: nombreTipo! !

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:21'!
new: nombreTipo

	^Tipo getInstance: nombreTipo.! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:23'!
checkValueIsValid: valor
	^ #(0 1 2 0.5) includes: valor! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:18'!
efectividad: valor contra: nombreTipo
	(self checkValueIsValid: valor)
		ifTrue: [ efectividades at: nombreTipo put: valor ]! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 23:57'!
efectividadContra: nombreTipo 

	^efectividades at: nombreTipo ifAbsent: 1! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 23:53'!
initializeOnNombre: nombreTipo 

	nombre := nombreTipo.
	efectividades := Dictionary new.! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 23:46'!
nombre
	^nombre.! !

TestCase subclass: #PokemonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3-Pokemon'!

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:34'!
basicFuego

	^Tipo new: 'fuego'.! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:50'!
test01TypeShouldBeCreatedWithNameAndEfectiveness1
	|fuego|
	
	fuego:= self basicFuego.

	self assert: (fuego nombre = 'fuego').
	self assert: ((fuego efectividadContra: 'notType') = 1 )! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:43'!
test02TypeCanBeAskedForExistence
	|fuego|
	
	fuego:= self basicFuego.

	self assert: (Tipo existeTipo: 'fuego').
	self deny: (Tipo existeTipo: 'notType').! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:41'!
test03TypeCanRedefineEfectiveness
	|fuego|
	
	fuego:= self basicFuego.

	fuego efectividad: 1/2 contra: 'fuego'.
	self assert: ((fuego efectividadContra: 'fuego') = (1/2)).
	fuego efectividad: 1 contra: 'fuego'.
	self assert: ((fuego efectividadContra: 'fuego') = 1)! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:41'!
test04TypeCantRedefineEfectivenessOnNotAnEffectivenessValue
	|fuego|
	
	fuego:= self basicFuego.

	fuego efectividad: 3 contra: 'fuego'.
	self assert: ((fuego efectividadContra: 'fuego') = 1).
	fuego efectividad: -1 contra: 'fuego'.
	self assert: ((fuego efectividadContra: 'fuego') = 1).
	fuego efectividad: 3/4 contra: 'fuego'.
	self assert: ((fuego efectividadContra: 'fuego') = 1).! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:49'!
test05LoadInitialTypesLoadsCorrectValues
	|fuego agua fantasma planta normal|
	
	Tipo cargarTiposIniciales.
	
	self assert: (Tipo existeTipo: 'fuego').
	fuego := Tipo getInstance: 'fuego'.
	self assert: ((fuego efectividadContra: 'fuego') =  0.5).
	self assert: ((fuego efectividadContra: 'agua') = 0.5).
	self assert: ((fuego efectividadContra: 'planta') = 2).
	self assert: ((fuego efectividadContra: 'normal') = 1).
	self assert: ((fuego efectividadContra: 'fantasma') = 1).
	
	self assert: (Tipo existeTipo: 'agua').
	agua := Tipo getInstance: 'agua'.
	self assert: ((agua efectividadContra: 'fuego') =  2).
	self assert: ((agua efectividadContra: 'agua') = 0.5).
	self assert: ((agua efectividadContra: 'planta') = 0.5).
	self assert: ((agua efectividadContra: 'normal') = 1).
	self assert: ((agua efectividadContra: 'fantasma') = 1).
	
	self assert: (Tipo existeTipo: 'planta').
	planta := Tipo getInstance: 'planta'.
	self assert: ((planta efectividadContra: 'fuego') =  0.5).
	self assert: ((planta efectividadContra: 'agua') = 2).
	self assert: ((planta efectividadContra: 'planta') = 0.5).
	self assert: ((planta efectividadContra: 'normal') = 1).
	self assert: ((planta efectividadContra: 'fantasma') = 1).
	
	self assert: (Tipo existeTipo: 'normal').
	normal := Tipo getInstance: 'normal'.
	self assert: ((normal efectividadContra: 'fuego') =  1).
	self assert: ((normal efectividadContra: 'agua') = 1).
	self assert: ((normal efectividadContra: 'planta') = 1).
	self assert: ((normal efectividadContra: 'normal') = 1).
	self assert: ((normal efectividadContra: 'fantasma') = 0).
	
	self assert: (Tipo existeTipo: 'fantasma').
	fantasma := Tipo getInstance: 'fantasma'.
	self assert: ((fantasma efectividadContra: 'fuego') =  1).
	self assert: ((fantasma efectividadContra: 'agua') = 1).
	self assert: ((fantasma efectividadContra: 'planta') = 1).
	self assert: ((fantasma efectividadContra: 'normal') = 0).
	self assert: ((fantasma efectividadContra: 'fantasma') = 2).! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'NicolasRavasi 6/16/2012 02:31'!
test06PokemonClassDoesNotImplementSubclassSpecificMethods
	
	self assert: (self should: [Pokemon ataqueBase] raise: SubclassResponsibility).
	! !
